<?php 

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelFichTecUtilProdServ;

class RelFichTecUtilProd {
    protected $parameterBagColumns = array('CDPRODUTO');
    protected $relFichTecUtilProdServ;
   
    public function __construct($dataSourceManager, $parameterBag, $utilService, RelFichTecUtilProdServ $relFichTecUtilProdServ) {
        $this->utilService = $utilService;
        $this->relFichTecUtilProdServ = $relFichTecUtilProdServ;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $data=[];
        if(isset($conditions['CDPRODUTO'])){
            try{
                $data = $this->relFichTecUtilProdServ->getDados($conditions);
            } catch (\Exception $e){
                $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
            }
        }
        
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('RelFichTecUtilProd', $data));
    }
}

