<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelProdModTipocons {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find($conditions) {
        $params = array(
         	":CDFILIAL"    => $conditions['CDFILIAL'],
         	":CDLOJA"      => $conditions['CDLOJA'],
         	":TCDLOJA"     => $conditions['TCDLOJA'],
         	":DATAINI"     => $conditions['DATAINI'],
         	":DATAFIN"     => $conditions['DATAFIN'],
         	":MODALIDADE"  => $conditions['MODALIDADE'],
         	":TMODALIDADE" => $conditions['TMODALIDADE'],
         	":CDTIPOCONS"  => $conditions['CDTIPOCONS'],
         	":TCDTIPOCONS" => $conditions['TCDTIPOCONS'],
         	":SC"          => $conditions['SC'],
         	":NRORG"       => $conditions['NRORG'],
         	":FLAGBALTAA"  => $conditions['FLAGBALTAA'],
         	":CDOPERADOR"  => $conditions['CDOPERADOR']
 		);
 		
 		return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTO_POR_MODALIDADE_TIPOCONSUMIDOR, $params);
    }
    
    public function buildParamsFaturamento($conditions){
        if(!array_key_exists('CDFILIAL', $conditions)) {
            $conditions['CDFILIAL'] = '';
        } else {
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['CDOPERADOR'] = '';
        }
        
        if(!array_key_exists('CDLOJA', $conditions)) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        
        if(!array_key_exists('CDTIPOCONS', $conditions)) {
            $conditions['CDTIPOCONS'] = '';
            $conditions['TCDTIPOCONS'] = 'T';
        } else {
            $conditions['CDTIPOCONS'] = implode('_', $conditions['CDTIPOCONS']);
            $conditions['TCDTIPOCONS'] = '';
        }
        
        if(!array_key_exists('MODALIDADE', $conditions)) {
            $conditions['TMODALIDADE'] = 'T';
            $conditions['MODALIDADE'] = '';
        } else {
            $conditions['MODALIDADE'] = implode('_', $conditions['MODALIDADE']);
            $conditions['TMODALIDADE'] = 'E';
        }
        
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        
        $conditions['FLAGBALTAA'] = 'N';
        $conditions['FLAGBALTAA'] = (strpos($conditions['MODALIDADE'], 'BAL') !== false ? (strpos($conditions['MODALIDADE'], 'TAA') !== false ? 'N' : 'S') : 'N');
        
        return $conditions;
    }

    const GET_PRODUTO_POR_MODALIDADE_TIPOCONSUMIDOR = "
        SELECT FILOCAVECOTI.CDFILIAL||' - '||FILOCAVECOTI.NMFILIAL AS CODFILIAL, I.CDPRODUTO, P.NMPRODUTO, P.CDARVPROD, SUM(I.QTPRODVEND) AS QTOT, SUM(I.QTPRODVEND * ( NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)) - NVL(I.VRDESITVEND,0) + NVL(VRACRITVEND,0)) AS VRTOT,
               FILOCAVECOTI.NMTIPOCONS, FILOCAVECOTI.IDSITUVENDA, FILOCAVECOTI.CDLOJA, FILOCAVECOTI.NMLOJA,
               FILOCAVECOTI.CDFILIAL, FILOCAVECOTI.NMFILIAL, FILOCAVECOTI.NRORG, FILOCAVECOTI.CDTIPOCONS,
               FILOCAVECOTI.NMMODALIDADE, FILOCAVECOTI.CDTIPOCONS||' - '||FILOCAVECOTI.NMTIPOCONS AS LABELTIPOCONS, FILOCAVECOTI.NMMODALIDADE AS MODALIDADE
          FROM ITEMVENDA I
          JOIN PRODUTO P 
            ON I.CDPRODUTO = P.CDPRODUTO
           AND I.NRORG = P.NRORG
          JOIN (SELECT T.NMTIPOCONS, FILOCAVECO.IDSITUVENDA, FILOCAVECO.NRSEQVENDA, FILOCAVECO.CDCAIXA, FILOCAVECO.NMCAIXA, FILOCAVECO.CDLOJA, FILOCAVECO.NMLOJA, 
                 FILOCAVECO.CDFILIAL, FILOCAVECO.NMFILIAL, FILOCAVECO.NRORG, FILOCAVECO.DTENTRVENDA, FILOCAVECO.CDTIPOCONS, FILOCAVECO.CDCONSUMIDOR, FILOCAVECO.CDCLIENTE, 
                 FILOCAVECO.IDORIGEMVENDA AS NMMODALIDADE
          FROM TIPOCONS T
          JOIN (SELECT FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL,
                       FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, C.CDTIPOCONS, C.CDCONSUMIDOR, C.CDCLIENTE, FILOCAVE.IDORIGEMVENDA
                  FROM CONSUMIDOR C
                  JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                              FILOCA.NRORG, V.DTENTRVENDA, V.CDCONSUMIDOR, V.CDCLIENTE, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                                                                           WHEN 'DLV' THEN 'DELIVERY'
                                                                                           WHEN 'MES' THEN 'MESA'
                                                                                           WHEN 'BAL' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'AUT' THEN 'TERMINAL DE AUTO-ATENDIMENTO' ELSE 'BALCAO' END)
                                                                                           WHEN 'TAA' THEN 'TERMINAL DE AUTO-ATENDIMENTO'
                                                                                           WHEN 'CMD' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'THR' THEN 'DRIVE THRU' ELSE 'COMANDA' END)
                                                                                           WHEN 'AJU' THEN 'OUTROS'
                                                                                           ELSE 'OUTROS'
                                                                                         END AS IDORIGEMVENDA
                         FROM VENDA V
                         JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                 FROM CAIXA C
                                 JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                         FROM LOJA L
                                         JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                                 FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL, F.CDFILIAL) > 0) OR CDFILIAL IN (
                                                                SELECT CDFILIAL
                                                                    FROM FILIOPER
                                                                    WHERE CDOPERADOR = :CDOPERADOR
                                                            ))
                                                  AND F.NRORG = :NRORG ) FI 
                                           ON L.CDFILIAL = FI.CDFILIAL
                                          AND L.NRORG = FI.NRORG
                                        WHERE ((INSTR(:CDLOJA, FI.CDFILIAL ||L.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))) FILO 
                                   ON C.CDFILIAL = FILO.CDFILIAL 
                                  AND C.CDLOJA = FILO.CDLOJA
                                  AND C.NRORG = FILO.NRORG) FILOCA 
                           ON V.CDCAIXA = FILOCA.CDCAIXA
                          AND V.CDLOJA = FILOCA.CDLOJA
                          AND V.CDFILIAL = FILOCA.CDFILIAL
                          AND V.NRORG = FILOCA.NRORG
                        WHERE V.IDSITUVENDA = 'O'
                          AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                          AND ((INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 0, 3) ) > 0 OR INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 5, 7) ) > 0) OR ('T' = :TMODALIDADE))
                          AND V.IDORIGEMVENDA <> (CASE :FLAGBALTAA WHEN 'S' THEN 'BAL_AUT' ELSE 'ZZZZZZ' END)
                          ) FILOCAVE 
                     ON FILOCAVE.CDCONSUMIDOR = C.CDCONSUMIDOR
                    AND FILOCAVE.CDCLIENTE = C.CDCLIENTE
                    AND FILOCAVE.NRORG = C.NRORG ) FILOCAVECO
               ON FILOCAVECO.CDTIPOCONS = T.CDTIPOCONS
              AND FILOCAVECO.NRORG = T.NRORG
            WHERE (INSTR(:CDTIPOCONS, T.CDTIPOCONS) > 0) OR (:TCDTIPOCONS  = 'T') ) FILOCAVECOTI
           ON I.CDFILIAL = FILOCAVECOTI.CDFILIAL
          AND I.CDCAIXA = FILOCAVECOTI.CDCAIXA
          AND I.NRSEQVENDA = FILOCAVECOTI.NRSEQVENDA
          AND I.NRORG = FILOCAVECOTI.NRORG
        GROUP BY I.CDPRODUTO, P.NMPRODUTO, P.CDARVPROD, FILOCAVECOTI.NMTIPOCONS, FILOCAVECOTI.IDSITUVENDA, FILOCAVECOTI.CDLOJA, FILOCAVECOTI.NMLOJA,
               FILOCAVECOTI.CDFILIAL, FILOCAVECOTI.NMFILIAL, FILOCAVECOTI.NRORG, FILOCAVECOTI.CDTIPOCONS, FILOCAVECOTI.NMMODALIDADE

        UNION
        
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS CODFILIAL, I.CDPRODUTO, P.NMPRODUTO, P.CDARVPROD, SUM(I.QTPRODVEND) AS QTOT, 
               SUM(I.QTPRODVEND * ( NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)) - NVL(I.VRDESITVEND,0) + NVL(VRACRITVEND,0)) AS VRTOT,
               'Sem Consumidor' AS NMTIPOCONS, FILOCAVE.IDSITUVENDA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA,
               FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.NRORG, '00' AS CDTIPOCONS,
               FILOCAVE.NMMODALIDADE, 'Sem Consumidor' AS LABELTIPOCONS, FILOCAVE.NMMODALIDADE AS MODALIDADE
          FROM ITEMVENDA I
          JOIN PRODUTO P 
            ON I.CDPRODUTO = P.CDPRODUTO
           AND I.NRORG = P.NRORG
          JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                       FILOCA.NRORG, V.DTENTRVENDA, V.CDCONSUMIDOR, V.CDCLIENTE, CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
           WHEN 'DLV' THEN 'DELIVERY'
           WHEN 'MES' THEN 'MESA'
           WHEN 'BAL' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'AUT' THEN 'TERMINAL DE AUTO-ATENDIMENTO' ELSE 'BALCAO' END)
           WHEN 'TAA' THEN 'TERMINAL DE AUTO-ATENDIMENTO'
           WHEN 'CMD' THEN (CASE SUBSTR(V.IDORIGEMVENDA, 5, 7) WHEN 'THR' THEN 'DRIVE THRU' ELSE 'COMANDA' END)
           WHEN 'AJU' THEN 'OUTROS'
           ELSE 'OUTROS'
         END AS NMMODALIDADE
                  FROM VENDA V
                  JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                          FROM CAIXA C
                          JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                  FROM LOJA L
                                  JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                          FROM FILIAL F
                                         WHERE ((INSTR(:CDFILIAL, F.CDFILIAL) > 0) OR CDFILIAL IN (
                                                                SELECT CDFILIAL
                                                                    FROM FILIOPER
                                                                    WHERE CDOPERADOR = :CDOPERADOR
                                                            ))
                                           AND F.NRORG = :NRORG ) FI 
                                    ON L.CDFILIAL = FI.CDFILIAL
                                   AND L.NRORG = FI.NRORG
                                 WHERE ((INSTR(:CDLOJA, FI.CDFILIAL ||L.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))) FILO 
                            ON C.CDFILIAL = FILO.CDFILIAL 
                           AND C.CDLOJA = FILO.CDLOJA
                           AND C.NRORG = FILO.NRORG) FILOCA 
                    ON V.CDCAIXA = FILOCA.CDCAIXA
                   AND V.CDLOJA = FILOCA.CDLOJA
                   AND V.CDFILIAL = FILOCA.CDFILIAL
                   AND V.NRORG = FILOCA.NRORG
                 WHERE V.IDSITUVENDA = 'O'
                   AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                   AND V.CDCONSUMIDOR IS NULL
                   AND 'T' = :SC
                   AND ((INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 0, 3) ) > 0 OR INSTR(:MODALIDADE, SUBSTR(V.IDORIGEMVENDA, 5, 7) ) > 0) OR ('T' = :TMODALIDADE))
                   AND V.IDORIGEMVENDA <> (CASE :FLAGBALTAA WHEN 'S' THEN 'BAL_AUT' ELSE 'ZZZZZZ' END)
                ) FILOCAVE
            ON I.CDFILIAL = FILOCAVE.CDFILIAL
           AND I.CDCAIXA = FILOCAVE.CDCAIXA
           AND I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
           AND I.NRORG = FILOCAVE.NRORG
         GROUP BY I.CDPRODUTO, P.NMPRODUTO, P.CDARVPROD, FILOCAVE.IDSITUVENDA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA,
                  FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.NRORG, FILOCAVE.NMMODALIDADE
         ORDER BY 4
    ";
}